import java.text.*;
import java.util.*;
import java.io.*;
import java.sql.*;
import java.math.*;

public class DistBench
{
	// CHANGE DRIVER STRING HERE										//|
	public static final String DRIVER =									//|
		"nl.cwi.monetdb.jdbc.MonetDriver";								//|
		//"com.mysql.jdbc.Driver";										//|
																		//|
	// CHANGE DB CONNECTION STRING(S) HERE								//|
																		//|
	public static final String DB1 =									//|
		"jdbc:monetdb://localhost:45123/ggle_1";						//|
		//"jdbc:mysql://localhost/ggle?user=ggle&password=gsa#1";		//|
																		//|
	public static final String DB2 =									//|
		"jdbc:monetdb://localhost:45223/ggle_2";						//|


	public static Connection con1 = null, con2 = null;
	public static ParallelConnection pcon1 = null, pcon2 = null;
	public static ResultSet res1 = null, res2 = null;
	public static String query = "", sql = "";



	/*------------------------------------------------------------------ init()
	|																		  |
	| DOCUMENT ME!															  |
	\------------------------------------------------------------------------*/
	public static void init()
	{
		try
		{
			// get the driver
			Class.forName(DRIVER);

			// open connecvtions
			con1 = DriverManager.getConnection(DB1, "monetdb", "monetdb");
			con2 = DriverManager.getConnection(DB2, "monetdb", "monetdb");

			// turn off auto commit
			con1.setAutoCommit( false );
			con2.setAutoCommit( false );

			pcon1 =  new ParallelConnection(con1);
			pcon2 =  new ParallelConnection(con2);

			pcon1.start();
			pcon2.start();
		}
		catch(Exception e)
		{
			System.out.println("COULDN'T EVEN START: " +e);
			return;
		}
	}

	/*--------------------------------------------------------------- doQuery()
	|																		  |
	| DOCUMENT ME!															  |
	\------------------------------------------------------------------------*/
	public static void doQuery( int i ) throws Exception
	{
		switch(i)
		{
			case 0:
				query = "SELECT EntryId, URL " +
						"	FROM Entry " +
						"	WHERE url = 'http://www.php.net/index.php'";

				pcon1.createStatement( "stmt");
				pcon2.createStatement( "stmt");

				pcon1.executeQuery( "stmt", query);
				pcon2.executeQuery( "stmt", query);

				res1 = pcon1.getResult( "stmt");
				res2 = pcon2.getResult( "stmt");
				break;

			case 1:
				query = "SELECT URL FROM Entry " +
						"	WHERE LOWER(Domain) LIKE '%math%' " +
						"		OR LOWER(Path) LIKE '%math%' " +
						"		OR LOWER(Page) LIKE '%math%'";



				pcon1.createStatement( "stmt");
				pcon2.createStatement( "stmt");

				pcon1.executeQuery( "stmt", query);
				pcon2.executeQuery( "stmt", query);

				res1 = pcon1.getResult( "stmt");
				res2 = pcon2.getResult( "stmt");
				break;

			case 2:
				query = "SELECT COUNT(*) FROM Entry UNION SELECT COUNT(*) FROM Link";



				pcon1.createStatement( "stmt");
				pcon2.createStatement( "stmt");

				pcon1.executeQuery( "stmt", query);
				pcon2.executeQuery( "stmt", query);

				res1 = pcon1.getResult( "stmt");
				res2 = pcon2.getResult( "stmt");
				break;

			case 3:

				Hashtable results = new Hashtable();
				query = "SELECT E.Domain, COUNT(L.Entry) AS Number_of_links " +
						"	FROM Entry E, Link L "	+
						"	WHERE L.Entry = EntryId " +
						"	GROUP BY E.Domain " +
						"	HAVING E.Domain = 'http://www.php.net'";



				pcon1.createStatement( "stmt");
				pcon2.createStatement( "stmt");

				pcon1.executeQuery( "stmt", query);
				pcon2.executeQuery( "stmt", query);

				res1 = pcon1.getResult( "stmt");
				res2 = pcon2.getResult( "stmt");

				String url; int count;

				while( res1.next() )
				{
					results.put( res1.getString(1), (Integer) res1.getObject(2) );
				}
				while( res2.next() )
				{
					url = res2.getString(1);

					if( results.containsKey(url) )
						results.put( url, new Integer(((Integer) results.get(url)).intValue()  +
													 ( (Integer) res2.getObject(2)).intValue())  );
					else
						results.put( res1.getString(1), (Integer) res1.getObject(2) );
				}
				break;

			case 4:
				query = "SELECT U.URL, COUNT(LinksTo) As num_linked_from " +
						   "	FROM Entry U, (SELECT LinksTo FROM Link UNION ALL SELECT LinksTo FROM Tmp1) AS L" +
						   "	WHERE EntryId = LinksTo AND (LOWER(U.Domain) LIKE '%math%' OR LOWER(U.Path) LIKE '%math%' " +
						   "	OR LOWER(U.Page) LIKE '%math%') " +
						   "	GROUP BY U.URL " +
						   "	ORDER BY num_linked_from DESC, U.url ";



				pcon1.createStatement( "stmt");
				pcon2.createStatement( "stmt");

				pcon1.executeQuery( "stmt", "SELECT LinksTo FROM Link WHERE MOD(LinksTo, 2) = 1");
				pcon2.executeQuery( "stmt", "SELECT LinksTo FROM Link WHERE MOD(LinksTo, 2) = 0");

				res1 = pcon1.getResult( "stmt");
				res2 = pcon2.getResult( "stmt");

				pcon1.executeUpdate( "stmt", "CREATE TABLE Tmp1( LinksTo INT )");
				pcon2.executeUpdate( "stmt", "CREATE TABLE Tmp1( LinksTo INT )");

				count = 0;

				while( res1.next() )
				{
					pcon2.addBatch( "stmt", "INSERT INTO Tmp1 VALUES ('" + res1.getInt(1) + "')");

					if( (count % 100 ) == 0 )
						pcon2.executeBatch( "stmt" );

					count++;
				}
				pcon2.executeBatch( "stmt" );

				count = 0;

				while( res2.next() )
				{
					pcon1.addBatch( "stmt", "INSERT INTO Tmp1 VALUES ('" + res2.getInt(1) + "')");

					if( (count % 50 ) == 0 )
						pcon1.executeBatch( "stmt" );

					count++;
				}
				pcon1.executeBatch( "stmt" );

				pcon1.executeQuery( "stmt", query );
				pcon2.executeQuery( "stmt", query );

				res1 = pcon1.getResult( "stmt");
				res2 = pcon2.getResult( "stmt");
				break;

			case 5:
				query = "SELECT URL FROM (SELECT DISTINCT URL FROM Entry " +
						"						WHERE Domain LIKE 'http:%' "   +
						" 				  UNION " +
						"				  SELECT DISTINCT URL FROM Link " +
						"						WHERE Domain LIKE 'http:%') AS Urls_table";
				sql = "CREATE VIEW Urls AS " + query;




				pcon1.createStatement( "stmt");
				pcon2.createStatement( "stmt");

				pcon1.executeQuery( "stmt", query);
				pcon2.executeUpdate( "stmt", sql);

				res1 = pcon1.getResult( "stmt");

				sql = "CREATE TABLE Tmp1( URL VARCHAR(200) )";
				pcon2.executeUpdate( "stmt", sql );

				count = 0;
				while( res1.next() )
				{
					if( res1.getString(1) != null)
						pcon2.addBatch( "stmt", "INSERT INTO Tmp1 VALUES ('" + res1.getString(1) + "')");

					if( (count % 50 ) == 0 )
						pcon2.executeBatch( "stmt" );

					count++;
				}
				pcon2.executeBatch( "stmt" );


				query = "SELECT COUNT(*) FROM (SELECT Url FROM Urls UNION SELECT Url FROM Tmp1) AS U";

				pcon2.executeQuery( "stmt", query);

				res2 = pcon2.getResult( "stmt");
				break;

			default:
				System.out.println("SOMETHING WENT HORRIBLY WRONG");
		}
	}




	/*------------------------------------------------------------------ main()
	|																		  |
	| DOCUMENT ME!															  |
	\------------------------------------------------------------------------*/
	public static void main (String argv[]) throws SQLException
	{
		FileWriter out = null;
		long start, end, time;
		int i, j;

		init();

		try
		{
			out = new FileWriter("resultDist.txt");

			System.out.println("starting .... ");


			out.write("RESPONSE TIME IN MILLISECONDS\n\n");
			out.write("\t\tMonetDB\n");
			out.write("-------------------------------------------\n");


			// --------------------------------------- loop through all queries
			for( i=0; i < 6; i++)
			{

				time = 0;
				// -------------------------------------- average over 20 times
				for( j=0; j < 21; j++)
				{

					start = System.currentTimeMillis();
					doQuery(i);
					end = System.currentTimeMillis();

					con1.rollback();
					con2.rollback();

					if( j != 0 )
						time += (end - start);

				}
				time = Math.round(time/(j-1));

				out.write("Query " + (i+1) + "\t|\t" + time + "\n");
			}

			out.write("\n\n\nRESPONSE TIME PER TRANSACTION OVER 20 RUNS\n\n");
			out.write("\t\tMonetDB\n");
			out.write("-------------------------------------------\n");

			// -------------------------------------------------- loop 20 runs
			for( i=0; i < 21; i++)
			{
				time = 0;
				// -------------------------------------- loop over all queries
				start = System.currentTimeMillis();
				for( j=0; j < 6; j++)
				{
					doQuery(j);
					con1.rollback();
					con2.rollback();
				}
				end = System.currentTimeMillis();

				time = end - start;

				out.write("Run " + (i+1) + "\t|\t"+ time + "\n");
			}

			pcon1.halt();
			pcon2.halt();

			out.close();
			con1.close();
			con2.close();

		}
		catch(Exception e)
		{

			try{ out.close(); }catch(Exception ex){System.out.println(ex); };
			System.out.println(e);
		}
	}
}
