import java.util.*;
import java.io.*;
import java.sql.*;


/*------------------------------------------------------------------ Link class
|																			  |
|					 Wrapper class for a Link in the GGLE db				  |
|																			  |
|																			  |
|																			  |
| 																			  |
\----------------------------------------------------------------------------*/
public class Link
{
	private int 	linkId;
	private int 	entry;
	private String 	domain	= "";
	private String 	path	= "";
	private String 	page	= "";
	private String 	url		= "";


	/*------------------------------------------------------------- constructor
	|																		  |
	| standart constructor													  |
	\------------------------------------------------------------------------*/
	public Link( String u )
	{
		linkId = 0;
		entry = 0;

		int first = u.indexOf('/', 8);
		int last = u.lastIndexOf('/') + 1;

		if( first != -1 )
		{
			domain 	= u.substring( 0, first );
			path 	= u.substring( first, last );
			page 	= u.substring( last );
		}
		else
		{
			domain = u;
		}
		url  = u;

	}


	/*--------------------------------------------------------- set() functions
	|																		  |
	| 																		  |
	\------------------------------------------------------------------------*/
	public void setLinkId( int id )
	{
		linkId = id;
	}

	public void setEntry( int id )
	{
		entry = id;
	}


	/*--------------------------------------------------------- get() functions
	|																		  |
	| 																		  |
	\------------------------------------------------------------------------*/
	public int getLinkId()
	{
		return linkId;
	}

	public int getEntry()
	{
		return entry;
	}

	public String getUrl()
	{
		return url ;
	}

	public String getDomain()
	{
		return domain ;
	}

	public String getPath()
	{
		return path ;
	}

	public String getPage()
	{
		return page ;
	}

	/*-------------------------------------------------------------- addBatch()
	|																		  |
	| 																		  |
	\------------------------------------------------------------------------*/
	public void addBatch( PreparedStatement pstmt )
	{
		try
		{
			pstmt.setInt	(	1, linkId 			);
			pstmt.setInt	(	2, entry 			);
			pstmt.setString	(	3, domain  			);
			pstmt.setString	(	4, path				);
			pstmt.setString	(	5, page				);
			pstmt.setString	(	6, url				);

			pstmt.addBatch();
		}
		catch( Exception e )
		{
			System.out.println(
			"ERROR while preparing insert statment for entry '" + url
			+ "'\nEXCEPTION: " + e);
		}
	}
}