import java.text.*;
import java.util.*;
import java.io.*;
import java.sql.*;
import java.math.*;





public class Query5
{
	// CHANGE DRIVER STRING HERE										//|
	public static final String DRIVER =									//|
		"nl.cwi.monetdb.jdbc.MonetDriver";								//|
		//"com.mysql.jdbc.Driver";										//|
																		//|
	// CHANGE DB CONNECTION STRING(S) HERE								//|
																		//|
	public static final String DB1 =									//|
		"jdbc:monetdb://localhost:45123/ggle";							//|
		//"jdbc:mysql://localhost/ggle?user=ggle&password=gsa#1";		//|
																		//|
	public static final String DB2 =									//|
		"jdbc:monetdb://localhost:45223/ggle";							//|



	public static void main (String argv[]) throws SQLException
	{
		Connection con1, con2;
		ParallelConnection pcon1, pcon2;
		ResultSet res1, res2;
		long start, end;
		String query = "";

		try
		{
			// get the driver
			Class.forName(DRIVER);

			// open connecvtions
			con1 = DriverManager.getConnection(DB1, "monetdb", "monetdb");
			con2 = DriverManager.getConnection(DB2, "monetdb", "monetdb");

			// turn off auto commit
			con1.setAutoCommit( false );
			con2.setAutoCommit( false );

			pcon1 =  new ParallelConnection(con1);
			pcon2 =  new ParallelConnection(con2);
			pcon1.start();
			pcon2.start();
		}
		catch(Exception e)
		{
			System.out.println("COULDN'T EVEN START: " +e);
			return;
		}



		System.out.println("Connectons open. Executing query ...");


		try
		{
			query = "SELECT U.URL, COUNT(LinksTo) As num_linked_from " +
					   "	FROM Entry U, (SELECT LinksTo FROM Link UNION ALL SELECT LinksTo FROM Tmp1) AS L" +
					   "	WHERE EntryId = L.LinksTo AND (LOWER(U.Domain) LIKE '%math%' OR LOWER(U.Path) LIKE '%math%' " +
					   "	OR LOWER(U.Page) LIKE '%math%') " +
					   "	GROUP BY U.URL " +
					   "	ORDER BY num_linked_from DESC, U.url ";



			pcon1.createStatement( "stmt");
			pcon2.createStatement( "stmt");

			pcon1.executeQuery( "stmt", "SELECT LinksTo FROM Link WHERE MOD(LinksTo, 2) = 1");
			pcon2.executeQuery( "stmt", "SELECT LinksTo FROM Link WHERE MOD(LinksTo, 2) = 0");

			res1 = pcon1.getResult( "stmt");
			res2 = pcon2.getResult( "stmt");

			pcon1.executeUpdate( "stmt", "CREATE TABLE Tmp1( LinksTo INT )");
			pcon2.executeUpdate( "stmt", "CREATE TABLE Tmp1( LinksTo INT )");

			int count = 0;

			while( res1.next() )
			{
				pcon2.addBatch( "stmt", "INSERT INTO Tmp1 VALUES ('" + res1.getInt(1) + "')");

				if( (count % 100 ) == 0 )
					pcon2.executeBatch( "stmt" );

				count++;
			}
			pcon2.executeBatch( "stmt" );

			count = 0;

			while( res2.next() )
			{
				pcon1.addBatch( "stmt", "INSERT INTO Tmp1 VALUES ('" + res2.getInt(1) + "')");

				if( (count % 100 ) == 0 )
					pcon1.executeBatch( "stmt" );

				count++;
			}
			pcon1.executeBatch( "stmt" );

			pcon1.executeQuery( "stmt", query );
			pcon2.executeQuery( "stmt", query );

			res1 = pcon1.getResult( "stmt");
			res2 = pcon2.getResult( "stmt");


			int f = 0, s = 0;
			boolean first  = res1.next();
			boolean second = res2.next();

			count = 0;
			while( count < 10 && (first  || second) )
			{
				if( first )
					f = res1.getInt(2);
				else
					f = 0;

				if( second)
					s = res2.getInt(2);
				else
					s = 0;

				if ( f < s )
				{
					System.out.println( res2.getString(1) + "\t\t\t\t\t" + res2.getInt(2) );
					second = res2.next();
					count++;
			 	}
				else if ( f > s )
				{
					System.out.println( res1.getString(1) + "\t\t\t\t\t" + res1.getInt(2) );
					first = res1.next();
					count++;
				}
				else
				{
					System.out.println( res1.getString(1) + "\t\t\t\t\t" + res1.getInt(2) );
					System.out.println( res2.getString(1) + "\t\t\t\t\t" + res2.getInt(2) );
					first = res1.next(); second = res2.next();
					count++; count++;
				}

			}

		}
		catch(Exception e)
		{
			System.out.println(e);
		}

		pcon1.halt();
		pcon2.halt();

		try
		{
			con1.rollback();
			con2.rollback();
			con1.close();
			con2.close();
		}
		catch(Exception e)
		{
			System.out.println(e);
		}

		System.out.println("FINISHED :-)");

	}
}
